#include <stdio.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
#include "crcmodel.c"

static   unsigned char buforg[66001];
static   unsigned char bufcus[66001];
static   unsigned char bufpat[150001];
//
// 27.10.2008 okaegi generate custom rom  based on orginal rom and patchinfo
// file structure look into genpatch.c
// 

unsigned long crc_32(unsigned char *buf,unsigned int len){
    //
    cm_t cmt;
    p_cm_t pcmt;
    int i;
    unsigned long crc;
    pcmt=&cmt;
    pcmt->cm_width = 32;             
    pcmt->cm_poly  = 0x4C11DB7L;                                       
    pcmt->cm_init  = 0xFFFFFFFFL;  
    pcmt->cm_refin = TRUE;
    pcmt->cm_refot = TRUE;
    pcmt->cm_xorot = 0xFFFFFFFFL;     
    
    cm_ini(pcmt);
    cm_blk(pcmt,buf,len);
    
    crc=cm_crc(pcmt);
    return(crc);
};
main(int argc,char *argv[])
{	
  unsigned long crc32,crc32r;
  int finorg,finpat,finout,fout;
  long i;
  char fileout[60];
  char fileorg[60];  
  char filepat[60];

 if (argc != 4) {
 	printf("gencust rom.org patchfile outputcustrom\n");
 	return -1;
 }

  printf("gencust:based on  orignal rom (%s) and patchfile (%s) custom rom ist created %s\n", argv[1],argv[2],argv[3]) ;  
  printf("by okaegi v1.2 \n");    	
  sprintf(fileorg,"%s",argv[1]);
  sprintf(filepat,"%s",argv[2]);
  sprintf(fileout,"%s",argv[3]);
  finorg = open(fileorg,O_RDONLY|O_BINARY);
  if (finorg == -1) {
	  	printf("cant open %s...\n", fileorg);  
         	return -1;
 	}
  read(finorg,buforg,0x10000);	
  close(finorg);
  finpat = open(filepat,O_RDONLY|O_BINARY);
  if (finpat == -1) {
	  	printf("cant open %s...\n", filepat);  
         	return -1;
 	}
  read(finpat,bufpat,0x20100);	
  close(finpat);
  memcpy(&crc32r,&bufpat[0x20010],sizeof(crc32r));
  printf("gencust read crc-32 from %s ->  %x\n",filepat,crc32r);

  memset(bufcus,0x00,0x10000);
  for (i = 0 ;i<=0x10000;i++) {
// FF erase in buforg and bufcus
      if (bufpat[i*2] == 0xff) {
      		buforg[i] = 0x00;
      		bufcus[i] = 0x00;
  	  } 
// 01 move into bufcus 	  
      else if (bufpat[i*2] == 0x01) {
      		buforg[i] = 0x00;
                bufcus[i] = bufpat[(i*2)+1];
  	  } 
// 00 xor buforg with bufpat  	  
      else if (bufpat[i*2] == 0x00) {
                bufcus[i] = bufpat[(i*2)+1] ^ buforg[i];
//      		printf ("gencust %05x buforg byte %02x bufpat byte %02x bufcus byte %02x\n",i,buforg[i],bufpat[(i*2)+1],bufcus[i]);
// 		if (bufpat[(i*2)+1] != 0x00) { return -1;}
// org custom -> patch (xor)   org -> custom (xor)
// 1     1    -> 0		1	1
// 1     0    -> 1		1       0
// 0     1    -> 1		0       1 
// 0     0    -> 0		0       0

          } 
      else {
      		printf ("gencust patchfile wrong control byte %02x",bufpat[i*2]);
          	return -1;
      }
  } 
  crc32=crc_32(buforg,0x10000);
  printf("gencust %s calculated crc-32 %x\n",fileorg,crc32);
  if (crc32 == crc32r) {
  	printf("gencust %s is original rom file , applying patch %s now and creating custom rom %s\n",fileorg,filepat,fileout);
  } else {
  	printf("gencust %s is not original rom file, please dump again\n",fileorg);
  	return -1;
  }

  fout = creat(fileout,666);
  if (fout == -1) {
      printf("gencust cant open %s as output\n", fileout);  
      return -1;
   }
  close(fout);
  fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  if (fout == -1) {
      printf("gencust cant open %s as output\n", fileout);  
      return -1;
  }
  write(fout,bufcus,0x10000);
  close(fout);


}
